/*
 *	lpd  -  iiasa c version
 *
 *	assumes existence of header routine (/bin/header)
 */
struct	{
	int inum;
	char name[14];
	} directory;

char	string[36];
char	dbuf[66];
char	*q		"";
char	raw[]		"/dev/rlp";
char	nonraw[]	"/dev/lp";
char	*lpname;
int	type;
int	old;
int	dfile;
int	opened;
main()
{
	register int dir;
	signal(1,1);
	signal(2,1);
	signal(3,1);
	chdir("/mnt/lpd");
	if(stat("lock",string)!= -1)exit();
	close(creat("lock",0000));
	if(fork())exit();

	dir=open(".",0);
	for(;;) {
		if(read(dir,&directory,16)!=16) {
			if(!old) {
				unlink("lock");
				exit();
			}
			seek(dir,0,0);
			old=0;
		}
		if(directory.inum==0)continue;
		if(directory.name[0]=='d' && directory.name[1]=='f') {
			gotone(directory.name);
			close(dfile);
			unlink(directory.name);
		}
	}
}

gotone(name)
{
	register i, fdes, firstime;
	int cbuf[256], wstat;
	char c;

	old++;
	if((dfile=open(name,0)) < 0) {
		unlink(name);
		return;
	}
	if((c = getch()) != type) {
		if(opened) close(opened);
		opened = 0;
		if((type = c) == 'r') lpname = raw;
		else lpname = nonraw;
	}
	if(!opened) {
		close(1);
		while((opened = open(lpname, 1)) < 0) sleep(10);
	}
	if(!getname())return;
	if(!fork()) {
		execl("/bin/header", "header", "-d", string,0);
		exit();
	}
	wait(&wstat);
	for(;;) {
		if((c=getch())=='F') {		/* that's a capital 'F' */
			if(!getname())return;
			if((fdes=open(string,0))<0)continue;
			firstime = 1;
			while((i=read(fdes,cbuf,512)) > 0) {
				if(firstime) {
					if(*cbuf == 0407 || *cbuf == 0410 || *cbuf == 0411 || *cbuf == 01 || *cbuf == 0123456) {
						write(opened,"Cannot print binary file\n",25);
						break;
					}
					firstime = 0;
				}
				write(opened,cbuf,i);
			}
			close(fdes);
			write(opened,"\014" ,1);
		}
		if(c=='U') {			/* that's a capital 'U' */
			if(!getname())return;
			unlink(string);
		}
		if(!c) {
			if(type == 'r') write(opened, "\014\014", 2);
			return;
		}
	}
}

getname()
{
	register char *p;
	p=string;
	while((*p = getch())!='\n' && *p++);
	if(*p!='\n')return(0);
	*p=0;
	return(1);
}

getch()
{
	register int i;

	if(!*q) {
		if((i=read(dfile,dbuf,64))<=0)return(0);
		dbuf[i]=0;
		q=dbuf;
	}
	return(*q++);
}
