#include	"hsh.h"


int	copy[]	   { 2, " (from) ", REQRD|EXST|SCAN,
			" (to) ", REQRD|NEW_OLD|CONFIRM };
int	delete[]   { 10, " (files) ", REQRD|EXST|SCAN|CONFIRM|QOB, 0 };
int	rename[]   { 2, " (oldname) ", REQRD|EXST|SCAN,
			" (to) ", REQRD|NEW_OLD|CONFIRM };
int	lnkname[]  { 2, " (to oldfile) ", EXST|SCAN|REQRD,
			" (alias) ", NOEXST|REQRD|CONFIRM };
int	teco[]	   { 2, " <oldfile> ", EXST|SCAN|DSHALWD, 0 };
int	make[]	   { 1, " (newfile) ", REQRD|NOEXST };
int	runcmd[]   { 10, " (program) ", REQRD|QOB, "",0,0 };
int	directry[] { 10, " <files> ", QOB,0,0 };
int	oneplus[]  { 10, " (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB,
			" (files) ", REQRD|EXST|DSHALWD|QOB };
int	assemcmd[] { 10, " (files) " ,REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB,
			" (files) ", REQRD|DSHALWD|QOB };
int	note[]	   { 2, " <topic> ", SPCL|QOB, 0 };
int	sttyx[]	   { 10, " <modes> ", SPCL|QOB, 0 };
int	writex[]   { 2, " (to user) ", REQRD|SPCL|QOB, "",0,0 };
int	mailx[]	   { 2, " mail <to user> ", SPCL, 0 };
int	srccom[]   { 2, " (file) ", REQRD|EXST|SCAN,
			" (with) ", REQRD|EXST|SCAN };
int	noargs[] { 1, "", SPCL|CONFIRM|AUTO };
int	ncnoargs[] { 1, "", AUTO|SPCL };
int	whoison[]  { 1, " is on:", AUTO|SPCL };
int	systat[]   { 9, " <arg> ", SPCL|QOB, 0 };
int	msgs[]	   { 1, " <y/n> ", SPCL };
int	totalcmd[] { 1, " disk useage:", AUTO|SPCL };
int	typecmd[]  { 9, " (files) ", REQRD|EXST|QOB, "", EXST|QOB, 0 };
int	changdir[] { 1, " <to directory> ", EXST|SPCL };
int	setprcmd[] { 6, " (on file) ", REQRD|EXST|SCAN, " <to> ", 0,0 };
int	locatcmd[] { 10, " (names) ", REQRD|SPCL|QOB, "",QOB,0 };
int	infocmd[]  { 10, " (on users) ", REQRD|QOB, "",0, 0 };
int	qote[]	   { 1, " of the day:", AUTO|SPCL };
int	news[]	   { 10, " <args> ", QOB, "", QOB,0 };
int	getcmd[]   { 10, " (from) ", REQRD, " (files) ", REQRD|QOB, "",QOB,0 };
int	printcmd[] { 10, " (files) ", EXST|DSHALWD, 0 };
int	aliascmd[] { 1, " <to user> ", SPCL };
int	ddtcmd[]   { 10, " (program) ", REQRD|EXST|SCAN, 0 };
int	fsave[]	{ 10, " (on drive number) ", REQRD|DSHALWD|QOB, 0 };





/*
 *	the first entries in database are position dependent
 *	(see switch @ doit:)
 *	 ***** change PDARGN to reflect any additions 
 *		or removals *****
 */
int	database[] {
	"bye",		noargs,
	"quiet",	noargs,
	"verbose",	ncnoargs,
	"unix shell",	noargs,
	"time",		ncnoargs,
	"run",		runcmd,
	"change",	changdir,
	"directory",	directry,
/*
 *		end of position dependent portion
 */
	"files",	directry,
	"total",	totalcmd,
	"copy",		copy,
	"delete",	delete,
	"rename",	rename,
	"type",		typecmd,
	"print",	printcmd,
	"srccom",	srccom,
	"lnk",		lnkname,
	"make",		make,
	"teco",		teco,
	"edit",		teco,
	"talk",		writex,
	"messages",	msgs,
	"post",		mailx,
	"who",		whoison,
	"locate",	locatcmd,
	"date",		ncnoargs,
	"systat",	systat,
	"news",		news,
	"help",		note,
	"note",		note,
	"setprotect",	setprcmd,
	"stty",		sttyx,		/* lower case */
	"STTY",		sttyx,		/* upper case */
	"ppl",		ncnoargs,
	"basic",	directry,
	"l110",		ncnoargs,
	"fortran",	oneplus,
	"assemble",	assemcmd,
	"linkr",	assemcmd,
	"cc",		oneplus,
	"fs",		fsave,
	0,		0,
};
