/*
 * cp oldfile newfile
 */

struct stats {
	int  minmaj;
	int  inumber;
	int  flags;
	char links;
	char uid;
	char gid;
	char size0;
	int  size1;
	int  addr[8];
	int  actime[2];
	int  modtime[2];
	};

	struct stats stat1;
	struct stats stat2;
	int buf[256];

main(argc,argv)
char **argv;
{
	int fold, fnew, n;
	register char *p1, *p2, *bp;
	int mode;

	if(argc != 3) {
		write(1, "Usage: cp oldfile newfile\n", 26);
		exit(1);
	}
	if((fold = open(argv[1], 0)) < 0) {
		write(1, "Cannot open old file.\n", 22);
		exit(1);
	}
	fstat(fold, &stat1);
	mode = stat1.flags;
	/* is target a directory? */
	if (stat(argv[2], &stat2)>=0 && ((stat2.flags)&060000)==040000) {
		p1 = argv[1];
		p2 = argv[2];
		bp = buf;
		while(*bp++ = *p2++);
		bp[-1] = '/';
		p2 = bp;
		while(*bp = *p1++)
			if(*bp++ == '/')
				bp = p2;
		argv[2] = buf;
	}
	if (stat(argv[2], &stat2) >= 0) {
		if(stat1.inumber == stat2.inumber &&
			stat1.minmaj == stat2.minmaj) {
				write(1, "Copying file to itself.\n", 24);
				exit(1);
		}
	}
	if ((fnew = creat(argv[2], mode)) < 0) {
		write(1, "Can't create new file.\n", 23);
		exit(1);
	}
	while(n = read(fold,  buf,  512)) {
	if(n < 0) {
		write(1, "Read error\n", 11);
		exit(1);
	} else
		if(write(fnew, buf, n) != n){
			write(1, "Write error.\n", 13);
			exit(1);
		}
	}
	exit(0);
}
