int	cardp;
int	qcnt;
char	buf[512];
char	out[80];
int	lmax;
int	seqflg;
int	digcnt;
float	maxseq;
float	seqno;

main(argc,argv)
char **argv;
{
	register char *line;
	register t, j;
	int file, cnt, trunc, i;

	argv++;
	if(argc > 1 && *argv[0] == '-') {
		setseq(*argv);
		lmax = 72;
		seqflg++;
		--argc;
		argv++;
	} else lmax = 80;
	if(argc <= 1) {
		file = 0;
	} else {
		if((file = open(*argv,0)) <   0) {
			perror(*argv);
			exit();
		}
	}

	if((cardp = open("/dev/cs",1)) < 0) {
		perror("/dev/cs open");
		exit();
	}

	j = trunc = 0;
	while((cnt = read(file,buf,512)) > 0) {
		line = buf;
		for(t = 0; t < cnt; t++) {
			if(*line == '\t') {
				i = 8 - (j%8);
				j =+ i;
				while(--i >= 0) putcha(' ');
			} else if(*line == '\n') {
					if(j > lmax) trunc++;
					while(j++ < lmax) putcha(' ');
					flsh();
					j = 0;
			} else {
				putcha(*line);
				j++;
			}
			line++;
		}
	}
	if(trunc) printf("%d records truncated\n",trunc);
}

putcha(c)
char c;
{
	if(qcnt < lmax) out[qcnt] = c;
	qcnt++;
}

flsh()
{
	if(seqflg) getseq();
	if(write(cardp,out,80) < 0) {
		perror("/dev/cs write");
		exit();
	}
	qcnt = 0;
write(cardp,"\n",1); /* remove this line when punch drive doesn't want LF's */
}

setseq(sl)
char *sl;
{
	register char *s;
	register p, i;
	char *t;

	s = sl;
	s++;	/* Move past '-' */
	for(i = 72; (*s < '0' || *s > '9') && *s; i++) out[i] = *s++;	/* Get chars */
	if(*s == 0) {
		write(1,"Sequence error\n",15);
		exit();
	}
	t = s;
	while(*s) seqno = seqno * 10 + (*s++ - '0');	/* Get digits */
	if(s - sl != 9) {
		write(1,"Sequence error\n",15);
		exit();
	}
	i = digcnt = s - t;
	if(digcnt > 6) {
		write(1,"Too many digits\n",16);
		exit();
	}
	maxseq = 1;
	while(i--) maxseq =* 10;
}

getseq()
{
	register i, tmp;

	float t;
	if(seqno >= maxseq) seqno =- maxseq;
	t = maxseq;
	for(i = 80 - digcnt; i < 80; i++) {
		tmp = seqno / (t =/ 10);
		if(tmp < 0) tmp = 0;
		while(tmp >= 10) tmp =- 10;
		out[i] = tmp + '0';
	}
	seqno =+ 10;
}
