#
struct inode {
	char minor;
	char major;
	int inumber;
	int flags;
	char nlinks;
	char uid;
	char gid;
	char size0;
	int size1;
	int addr[8];
	int actime[2];
	int modtime[2];
	};

#include "/usr/sys/param.h"
#include "/usr/sys/proc.h"
#define	NDH11	16
#define	NKL11	1
#define	NDL11	2
#include "/usr/sys/tty.h"
#include "/usr/sys/user.h"
struct {
	char name[8];
	int  type;
	char  *value;
} nl[5];
struct proc proc[1];
struct user u;
int	stbuf[257];
int hmem;
int swap;
int mem;
char *mtn;
char *rmtn;
char usrname[50];
char *mesg1 "bad arg count\n";
char *mesg2 "drive %c not assigned to you\n";
main(argc, argv)
int argc;
char **argv;
{
	struct proc *p;
	struct inode buff;
	int n, b;
	int i;
	int uid, puid;
	char cuid;
	rmtn = "/dev/rmt?";
	mtn = "/dev/mt?";
	if(argv[1][0] == '-' && argv[1][1] == 'q')
	{
	cuid = getuid();
	if((stat("/dev/rmt0",&buff) < 0 || cuid != buff.uid)
		&& (stat("/dev/rmt1",&buff) <0 || cuid != buff.uid))
				exit(0);
	setset();
	n = &proc[1];
	b = &proc;
	n =- b;
	seek(hmem, nl[0].value, 0);
	uid = getuid() & 0377;
	for (i=0; i<NPROC; i++) {
		read(hmem, proc, n);
		if (i<2 && proc[0].p_pid!=i)
			{printf("bad namelist\n"); exit(1);}
		if (proc[0].p_stat==0)
			continue;
		puid = proc[0].p_uid & 0377;
		if(uid == puid) exit(0);
		}
	remain(--argc,&argv[1],0);
	}
	else	{
		if(argv[1][0]=='-' && argv[1][1]=='f')
			force(--argc,&argv[1]);
		remain(argc,argv,1);
		}
}
remain(argc,argv,sw)
int argc, sw;
char **argv;
{
	char c;
	int i;
	if(argc==1){
		c = '0';
		rel(c,sw);
		c = '1';
		rel(c,sw);
	}
	else {
	for(i=1;i<argc;i++)
		{
		c = argv[i][0];
		rel(c,sw);
		}
	     }
}
rel(c,sw)
char c;
int sw;
{
	int fil; char name;
	struct inode *buf,buff;
	buf = &buff;
		rmtn[8] = c;
		mtn[7] = c;
		name = getuid();
		fil = stat(rmtn,buf);
		if(fil>=0)
			{
			if((buf->uid == name) && (buf->flags&0777) != 0666)
				{
				chmod(rmtn,0666);
				chmod(mtn,0666);
				chown(rmtn,'\0');
				chown(mtn,'\0');
				if(sw)printf("drive %c released\n",c);
				}
			else if(sw)printf(mesg2,c);
		}
		else perror(rmtn);
		}
force(argc, argv)
int argc;
char **argv;
{
	struct proc *p;
	struct inode buff;
	int n, b;
	int i, j, ii;
	int header;
	int tuid, puid;
	char cuid;
	char c;
	header=0;
	setset();
	if(argc==1)
		{
		printf("no args\n");
		exit();
		}
	for(j=1;j<argc;j++)
		{
		rmtn[8]=argv[j][0];
		if(stat(rmtn,&buff)<0)
			{
			perror(rmtn);
			exit();
			}
		if(((buff.flags&0777)==0666) && (buff.uid==0))
			{
			printf("Tape drive %s not assigned\n",argv[j]);
			continue;
			}
		printf("Tape drive %s assignee ",argv[j]);
		tuid=buff.uid;
		getpw(tuid,usrname);
		ii=0;
		while(usrname[ii]!=':')putchar(usrname[ii++]);
		n = &proc[1];
		b = &proc;
		n =- b;
		seek(hmem, nl[0].value, 0);
		for (i=0; i<NPROC; i++) 
			{
			read(hmem, proc, n);
			if (i<2 && proc[0].p_pid!=i)
				{printf("bad namelist\n"); exit(1);}
			if (proc[0].p_stat==0)
				continue;
			puid = proc[0].p_uid & 0377;
			if(tuid==puid)
				{
				if(!header)
					{
					printf(" owns process(es):\n   ps   command\n");
					header=1;
					}
				printf("%6d  ",proc[0].p_pid);
				prcom();
				}
			}
		if(!header)printf(" owns no processes\n");
			{
			printf("Still want to release tape drive %s?  ",argv[j]);
			c=getchar();
			if(c != '\n') while(getchar() != '\n');
			if(c == 'y')
				{
				if(frel(argv[j][0]))printf("tape drive %s released\n",argv[j]);
				else perror("release");
				}
			else printf("tape drive %s not released\n",argv[j]);
			header=0;
			}
		}
	exit();
}
frel(c)char c;
{
	int ret;
	rmtn[8]=c;
	mtn[7]=c;
	ret=1;
	if(chmod(rmtn,0666)<0)ret=0;
	if(chmod(mtn,0666)<0)ret=0;
	if(chown(rmtn,'\0')<0)ret=0;
	if(chown(mtn,'\0')<0)ret=0;
	return(ret);
}
setset()
{
	setup(&nl[0], "_proc");
	setup(&nl[1], "_dc11");
	setup(&nl[2], "_kl11");
	setup(&nl[3], "_dh11");
	nlist("/unix", nl);
	if (nl[0].type==0) {
		printf("No namelist\n");
		exit();
	}
	if ((hmem = open("/dev/mem", 0)) < 0) {
		printf("No mem\n");
		exit();
	}
	if((swap=open("/dev/swap",0))<0)
		{
		printf("no swap\n");
		exit();
		}
	/* need mem opened again w/ different descriptor */
	if((mem=open("/dev/mem",0))<0)
		{
		printf("no mem\n");
		exit();
		}
}
setup(p, s)
char *p, *s;
{
	while (*p++ = *s++);
}
prcom()
{
	int baddr, laddr, mf;
	int *ip;
	char *cp, *cp1;
	int c;
	baddr=0;
	laddr=0;
	if(proc[0].p_flag&SLOAD)
		{
		laddr=proc[0].p_addr;
		mf=mem;
		}
	else	{
		baddr=proc[0].p_addr;
		mf=swap;
		}
	laddr =+ proc[0].p_size - 8;
	baddr =+ laddr>>3;
	laddr = (laddr&07)<<6;
	seek(mf,baddr,3);
	seek(mf,laddr,1);
	if(read(mf,stbuf,512)!=512)
		return(0);
	for(ip = &stbuf[256];ip > &stbuf[0];)
		{
		if(*--ip == -1)
			{
			cp = ip+1;
			if(*cp==0)
				cp++;
			for(cp1 = cp; cp1 < &stbuf[256]; cp1++)
				{
				c = *cp1;
				if(c==0)
					*cp1=' ';
				else if(c < ' ' || c > 0176)
					*cp1='?';
				}
			printf("%.70s\n",cp);
			return(1);
			}
		}
	return(0);
}
